## libtsm 4.0.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(libtsm
    LANGUAGES C
    VERSION 4.0.2
)

# Some meta data
## TODO: merge into project above after we require cmake 3.12
set(PROJECT_HOMEPAGE_URL "https://github.com/Aetf/libtsm")
## TODO: merge into project above after we require cmake 3.10
set(PROJECT_DESCRIPTION "terminal-emulator state machine")

#---------------------------------------------------------------------------------------
# Initial setups
#---------------------------------------------------------------------------------------
# Ensure out-of-source build
if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
    message(FATAL_ERROR "Usage: mkdir build; cmake ..")
endif()

# Include utilities
include(cmake/Utilities.cmake)
# For feature_summary
include(FeatureSummary)

# Extra build types
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Debug")
endif()
include(cmake/BuildTypes.cmake)

#---------------------------------------------------------------------------------------
# Options
#---------------------------------------------------------------------------------------
option(BUILD_SHARED_LIBS "Build as shared libraries" ON)
add_feature_info(BUILD_SHARED_LIBS BUILD_SHARED_LIBS "build as shared libraries")

option(BUILD_TESTING "Whether to build test suite in default target" OFF)
add_feature_info(BUILD_TESTING BUILD_TESTING "build unit tests")

# We enable a lot of debug options by default, so this option is really only for
# extended developer debug modes.
option(ENABLE_EXTRA_DEBUG "Whether to enable several non-standard debug options." OFF)
add_feature_info(ENABLE_EXTRA_DEBUG ENABLE_EXTRA_DEBUG "enable additional non-standard debug options")

# Whether to our gtktsm example. This is linux-only as it uses epoll and friends.
# Therefore, it's disabled by default.
option(BUILD_GTKTSM "Whether to build the gtktsm example" OFF)
add_feature_info(BUILD_GTKTSM BUILD_GTKTSM "build the gtktsm example, it requires gtk+-3 and friends and is linux-only.")

#---------------------------------------------------------------------------------------
# Find packages
#---------------------------------------------------------------------------------------
# Additional find modules
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/modules)

# GNU filesystem layout
include(GNUInstallDirs)

# We need xkbcommon for keysym definitions. If it's not found, we use our own
# private copy of xkbcommon-keysyms.h.
find_package(XKBCommon COMPONENTS KeySyms)
set_package_properties(XKBCommon PROPERTIES
    TYPE OPTIONAL
    PURPOSE "Needed for keysym definitions. Will use private copy if not found."
)

# Optionally, look for gtk+-3 and friends for gtktsm
if(BUILD_GTKTSM)
    find_package(GTK3)
    set_package_properties(GTK3 PROPERTIES
        TYPE REQUIRED
        PURPOSE "For gtktsm example"
    )

    find_package(Cairo)
    set_package_properties(Cairo PROPERTIES
        TYPE REQUIRED
        PURPOSE "For gtktsm example"
    )

    find_package(Pango)
    set_package_properties(Pango PROPERTIES
        TYPE REQUIRED
        PURPOSE "For gtktsm example"
    )

    find_package(PangoCairo)
    set_package_properties(PangoCairo PROPERTIES
        TYPE REQUIRED
        PURPOSE "For gtktsm example"
    )

    find_package(XKBCommon COMPONENTS XKBCommon)
    set_package_properties(XKBCommon PROPERTIES
        TYPE REQUIRED
        PURPOSE "For gtktsm example"
    )
endif()

if(BUILD_TESTING)
    enable_testing()
    find_package(Check)
    set_package_properties(Check PROPERTIES
        TYPE REQUIRED
        PURPOSE "For testing"
    )
endif()

feature_summary(INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES WHAT ALL)

#---------------------------------------------------------------------------------------
# Set compiler options and features
#---------------------------------------------------------------------------------------
# Only set compile options after any inclusion of third party code
include(cmake/CompileOptions.cmake)

# Pass infomation to config header
if(XKBCommon_KeySyms_FOUND)
    set(BUILD_HAVE_XKBCOMMON ON)
endif()
if(ENABLE_EXTRA_DEBUG)
    set(BUILD_ENABLE_DEBUG ON)
endif(ENABLE_EXTRA_DEBUG)
configure_file(src/config.h.in ${CMAKE_BINARY_DIR}/config.h)
include_directories(${CMAKE_BINARY_DIR})

#---------------------------------------------------------------------------------------
# Put code together
#---------------------------------------------------------------------------------------
# Venderoized external code
add_subdirectory(external)

add_subdirectory(src)

if(BUILD_TESTING)
    add_subdirectory(test)
endif(BUILD_TESTING)

#---------------------------------------------------------------------------------------
# Installation of other files
#---------------------------------------------------------------------------------------
# pkgconfig file for backward compatibility
configure_file(etc/libtsm.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libtsm.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libtsm.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

#Export the targets to a script
set(INSTALL_CMAKEDIR ${CMAKE_INSTALL_LIBDIR}/cmake/libtsm)
install(EXPORT tsm-targets
    FILE
    libtsm-targets.cmake
    NAMESPACE
    libtsm::
    DESTINATION
    ${INSTALL_CMAKEDIR}
)

#Create a ConfigVersion.cmake file
include(CMakePackageConfigHelpers)
write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/libtsm-config-version.cmake
    COMPATIBILITY SameMajorVersion
)

configure_package_config_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/etc/libtsm-config.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/libtsm-config.cmake
    PATH_VARS
        INSTALL_CMAKEDIR
    INSTALL_DESTINATION
        ${INSTALL_CMAKEDIR}
    NO_CHECK_REQUIRED_COMPONENTS_MACRO
)

#Install the config, configversion and custom find modules
install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/libtsm-config-version.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/libtsm-config.cmake
    DESTINATION ${INSTALL_CMAKEDIR}
)

=== test/CMakeLists.txt ===
#
# Tests
# These tests are included in a separate "test" target that can be run manually via `make test'
# But a more useful way to run the tests is using ctest, which runs valgrind on all tests.
# This is also the setup using in our CI.
# Note that ctest fails if _any_ leak is detected by valgrind. Thus, you
# need to have valgrind installed and libcheck running properly (without leaks)
# to make the tests succeed.

function(libtsm_add_test name)
    set(options)
    set(oneValueArgs)
    set(multiValueArgs LINK_LIBRARIES)
    cmake_parse_arguments(ARG "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

    add_executable(${name} ${name})
    if(ARG_LINK_LIBRARIES)
        target_link_libraries(${name} PRIVATE ${ARG_LINK_LIBRARIES})
    endif()
    add_test(NAME ${name} COMMAND ${name})
endfunction()

libtsm_add_test(test_htable
    LINK_LIBRARIES
        check::check
)
target_link_object_libraries(test_htable
    PRIVATE
        shl
)

libtsm_add_test(test_symbol
    LINK_LIBRARIES
        tsm_test
        check::check
)

libtsm_add_test(test_screen
    LINK_LIBRARIES
        tsm_test
        check::check
)

libtsm_add_test(test_vte
    LINK_LIBRARIES
        tsm_test
        check::check
)

# This is only a quick sanity check that verifies the
# valgrind tests work properly.
libtsm_add_test(test_valgrind
    LINK_LIBRARIES
        check::check
)
# mark the test as will fail in memcheck
set_tests_properties(test_valgrind PROPERTIES LABELS memcheck-xfail)

=== src/shared/CMakeLists.txt ===
#
# SHL - Static Helper Library
# The SHL subsystem contains several small code pieces used all over libtsm and
# other applications.
#
add_library(shl OBJECT
    shl-htable.c
    shl-pty.c
    shl-ring.c
)

target_include_directories(shl
    PUBLIC
        ${CMAKE_CURRENT_SOURCE_DIR}
)
set_target_properties(shl PROPERTIES
    C_VISIBILITY_PRESET hidden
    POSITION_INDEPENDENT_CODE ON
)
add_libtsm_compile_options(shl)

=== src/tsm/CMakeLists.txt ===
#
# libtsm
# Main library build instructions
#

#
# Use a separate object library that is shared between tsm and tsm_test
#
add_library(tsm_obj OBJECT
    tsm-render.c
    tsm-screen.c
    tsm-selection.c
    tsm-unicode.c
    tsm-vte.c
    tsm-vte-charsets.c
)
set_target_properties(tsm_obj PROPERTIES
    POSITION_INDEPENDENT_CODE ON
    C_VISIBILITY_PRESET hidden
)

# Fix include path for tsm_obj because it can't directly link to
# external and shl. TODO: remove after we require 3.12
foreach(lib IN ITEMS external shl)
    target_include_directories(tsm_obj PRIVATE $<TARGET_PROPERTY:${lib},INTERFACE_INCLUDE_DIRECTORIES>)
endforeach()

# Other non-compilation properties shared between tsm and tsm_test
function(apply_properties target)
    # TODO: set this on tsm_obj after we require 3.12
    # Link to dependencies
    target_link_object_libraries(${target}
        PRIVATE
            external
            shl
    )
    if(XKBCommon_KeySyms_FOUND)
        target_link_libraries(${target}
            PRIVATE
                XKB::KeySyms
        )
    endif()
    target_include_directories(${target}
        INTERFACE
            $<INSTALL_INTERFACE:include>
            $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    )
    set_target_properties(${target} PROPERTIES
        POSITION_INDEPENDENT_CODE ON
        C_VISIBILITY_PRESET hidden
        VERSION "${PROJECT_VERSION}"
        SOVERSION "${PROJECT_VERSION_MAJOR}"
        PUBLIC_HEADER "${CMAKE_CURRENT_SOURCE_DIR}/libtsm.h"
    )
    add_libtsm_compile_options(${target})
endfunction()

#
# Main production library
#
add_library(tsm)
target_link_object_libraries(tsm PRIVATE tsm_obj)
apply_properties(tsm)
# The production library additionally use version script
set_property(TARGET tsm APPEND_STRING
    PROPERTY
        LINK_FLAGS " -Wl,--version-script=\"${CMAKE_CURRENT_SOURCE_DIR}/libtsm.sym\""
)
set_property(TARGET tsm APPEND
    PROPERTY
        LINK_DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/libtsm.sym"
)

# Add an alias so that library can be used inside the build tree
add_library(libtsm::tsm ALIAS tsm)

#
# Add an additional static library for testing
#
if(BUILD_TESTING)
    # Must be static to avoid visibility=hidden
    add_library(tsm_test STATIC)
    target_link_object_libraries(tsm_test PRIVATE tsm_obj)
    apply_properties(tsm_test)
    # Additionally expose internal private header path
    target_include_directories(tsm_test
        INTERFACE
            $<TARGET_PROPERTY:shl,INTERFACE_INCLUDE_DIRECTORIES>
    )
endif()

#
# Installation
#
install(TARGETS tsm EXPORT tsm-targets
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
)

## libtsm 3

=== debian/changelog ===
libtsm (3-1) unstable; urgency=low

  * Initial release (Closes: #731893)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Thu, 19 Dec 2013 06:49:58 +0900

=== debian/control ===
Source: libtsm
Priority: optional
Maintainer: Nobuhiro Iwamatsu <iwamatsu@debian.org>
Build-Depends: debhelper (>= 9), dh-autoreconf, pkg-config, check,
	libxkbcommon-dev
Standards-Version: 3.9.4
Section: libs
Homepage: http://www.freedesktop.org/wiki/Software/kmscon/libtsm/
Vcs-Git: git://anonscm.debian.org/collab-maint/libtsm.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/libtsm.git;a=summary

Package: libtsm-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, libtsm3 (= ${binary:Version})
Description: Terminal-emulator State Machine - development
 TSM is a state machine for DEC VT100-VT520 compatible terminal
 emulators. It tries to support all common standards while keeping
 compatibility to existing emulators like xterm, gnome-terminal, konsole, ..
 . 
 TSM itself does not provide any rendering nor window management.
 It is a simple plain state machine without any external dependencies.
 It can be used to implement terminal emulators, but also to implement
 other applications that need to interpret terminal escape sequences.
 .       
 This library is very similar to libvte of the gnome project.
 However, libvte is highly bound to GTK+, which makes it unsuitable for
 non-graphics projects that need to parse escape sequences. Instead,
 TSM tries to restrict its API to terminal emulation only. Furthermore,
 TSM does not try to establish a new terminal emulation standard, but
 instead keeps compatibility as close to xterm as possible.
 This is why the TERM variable can be set to xterm-color256 with any
 TSM based terminal emulator.
 .
 This package contains the header files and static library needed to
 compile applications that use libtsm.

Package: libtsm3
Section: libs
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Terminal-emulator State Machine - runtime
 TSM is a state machine for DEC VT100-VT520 compatible terminal
 emulators. It tries to support all common standards while keeping
 compatibility to existing emulators like xterm, gnome-terminal, konsole, ..
 . 
 TSM itself does not provide any rendering nor window management.
 It is a simple plain state machine without any external dependencies.
 It can be used to implement terminal emulators, but also to implement
 other applications that need to interpret terminal escape sequences.
 .       
 This library is very similar to libvte of the gnome project.
 However, libvte is highly bound to GTK+, which makes it unsuitable for
 non-graphics projects that need to parse escape sequences. Instead,
 TSM tries to restrict its API to terminal emulation only. Furthermore,
 TSM does not try to establish a new terminal emulation standard, but
 instead keeps compatibility as close to xterm as possible.
 This is why the TERM variable can be set to xterm-color256 with any
 TSM based terminal emulator.
 .
 This package contains the libtsm runtime library.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with autoreconf

override_dh_autoreconf:
	dh_autoreconf --as-needed

override_dh_auto_configure:
	dh_auto_configure -- --disable-silent-rules

## libtsm 4.0.2

=== debian/changelog ===
libtsm (4.0.2-0.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Unbreak d/watch broken by Github changes.
  * Switch /usr/share/doc/libtsm-dev from dir to symlink on upgrade.
    Thanks to Andreas Beckmann for reporting this packaging error.
    (Closes: #1035764)

 -- Victor Westerhuis <victor@westerhu.is>  Tue, 09 May 2023 17:47:55 +0200

libtsm (4.0.2-0.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Ensure that the CMake config files always point to the shared library.
    (Closes: #1010350)

 -- Victor Westerhuis <victor@westerhu.is>  Fri, 29 Apr 2022 21:18:06 +0200

libtsm (4.0.2-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Revert Maintainer (replaced by mistake)
  * Drop Vcs fields

 -- Bastian Germann <bage@debian.org>  Thu, 28 Apr 2022 10:16:55 +0200

libtsm (4.0.2-0.1) unstable; urgency=medium

  * Non-maintainer upload
  * Switch upstream to maintained fork.
  * New upstream release. (Closes: #1004921)

 -- Victor Westerhuis <victor@westerhu.is>  Sat, 19 Feb 2022 18:41:17 +0100

=== debian/control ===
Source: libtsm
Maintainer: Nobuhiro Iwamatsu <iwamatsu@debian.org>
Section: libs
Priority: optional
Build-Depends: check <!nocheck>,
               cmake,
               debhelper-compat (= 13),
               libxkbcommon-dev,
               pkg-config,
Standards-Version: 4.6.0
Homepage: https://github.com/Aetf/libtsm
Rules-Requires-Root: no

Package: libtsm4
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Terminal-emulator State Machine - runtime
 TSM is a state machine for DEC VT100-VT520 compatible terminal
 emulators. It tries to support all common standards while keeping
 compatibility to existing emulators like xterm, gnome-terminal, konsole, ..
 .
 TSM itself does not provide any rendering nor window management.
 It is a simple plain state machine without any external dependencies.
 It can be used to implement terminal emulators, but also to implement
 other applications that need to interpret terminal escape sequences.
 .
 This library is very similar to libvte of the GNOME project.
 However, libvte is highly bound to GTK+, which makes it unsuitable for
 non-graphics projects that need to parse escape sequences. Instead,
 TSM tries to restrict its API to terminal emulation only. Furthermore,
 TSM does not try to establish a new terminal emulation standard, but
 instead keeps compatibility as close to xterm as possible.
 This is why the TERM variable can be set to xterm-color256 with any
 TSM based terminal emulator.
 .
 This package contains the libtsm runtime library.

Package: libtsm-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libtsm4 (= ${binary:Version}),
         ${misc:Depends},
Description: Terminal-emulator State Machine - development
 TSM is a state machine for DEC VT100-VT520 compatible terminal
 emulators. It tries to support all common standards while keeping
 compatibility to existing emulators like xterm, gnome-terminal, konsole, ..
 .
 TSM itself does not provide any rendering nor window management.
 It is a simple plain state machine without any external dependencies.
 It can be used to implement terminal emulators, but also to implement
 other applications that need to interpret terminal escape sequences.
 .
 This library is very similar to libvte of the GNOME project.
 However, libvte is highly bound to GTK+, which makes it unsuitable for
 non-graphics projects that need to parse escape sequences. Instead,
 TSM tries to restrict its API to terminal emulation only. Furthermore,
 TSM does not try to establish a new terminal emulation standard, but
 instead keeps compatibility as close to xterm as possible.
 This is why the TERM variable can be set to xterm-color256 with any
 TSM based terminal emulator.
 .
 This package contains the header files and static library needed to
 compile applications that use libtsm.

## libtsm 4.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project(libtsm
     LANGUAGES C
-    VERSION 4.0.2
+    VERSION 4.1.0
 )
 
 # Some meta data
@@ -21,6 +21,7 @@
 
 # Include utilities
 include(cmake/Utilities.cmake)
+include(cmake/JoinPaths.cmake)
 # For feature_summary
 include(FeatureSummary)
 
@@ -142,6 +143,8 @@
 # Installation of other files
 #---------------------------------------------------------------------------------------
 # pkgconfig file for backward compatibility
+join_paths(libdir_for_pc_file "\${exec_prefix}" "${CMAKE_INSTALL_LIBDIR}")
+join_paths(includedir_for_pc_file "\${prefix}" "${CMAKE_INSTALL_INCLUDEDIR}")
 configure_file(etc/libtsm.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libtsm.pc @ONLY)
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libtsm.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== external/CMakeLists.txt ===
#
# External vendorized code
# build everything into a object library for ease of use internally
#
add_library(external OBJECT
    wcwidth/wcwidth.c
)

target_include_directories(external
    PUBLIC
        ${CMAKE_CURRENT_SOURCE_DIR}
        ${CMAKE_CURRENT_SOURCE_DIR}/wcwidth
)
set_target_properties(external PROPERTIES
    C_VISIBILITY_PRESET hidden
    POSITION_INDEPENDENT_CODE ON
)
add_libtsm_compile_options(external)

=== src/CMakeLists.txt ===
add_subdirectory(shared)
add_subdirectory(tsm)

if(BUILD_GTKTSM)
    add_subdirectory(gtktsm)
endif()

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -41,7 +41,19 @@
         check::check
 )
 
+libtsm_add_test(test_selection
+    LINK_LIBRARIES
+        tsm_test
+        check::check
+)
+
 libtsm_add_test(test_vte
+    LINK_LIBRARIES
+        tsm_test
+        check::check
+)
+
+libtsm_add_test(test_vte_mouse
     LINK_LIBRARIES
         tsm_test
         check::check

=== src/gtktsm/CMakeLists.txt ===
#
# GtkTsm - Example
#
add_executable(gtktsm
    gtktsm.c
    gtktsm-app.c
    gtktsm-terminal.c
    gtktsm-win.c
)
target_link_libraries(gtktsm
    PRIVATE
        tsm

        m
        PkgConfig::GTK3
        PkgConfig::Cairo
        PkgConfig::Pango
        PkgConfig::PangoCairo
        XKB::XKBCommon
)
target_link_object_libraries(gtktsm
    PRIVATE
        shl
)
add_libtsm_compile_options(gtktsm)

install(TARGETS gtktsm
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
)

=== src/shared/CMakeLists.txt ===
--- 
+++ 
@@ -5,9 +5,11 @@
 #
 add_library(shl OBJECT
     shl-htable.c
-    shl-pty.c
-    shl-ring.c
 )
+
+if (BUILD_GTKTSM)
+    target_sources(shl PRIVATE shl-pty.c shl-ring.c)
+endif()
 
 target_include_directories(shl
     PUBLIC

=== src/tsm/CMakeLists.txt ===
--- 
+++ 
@@ -62,6 +62,7 @@
 target_link_object_libraries(tsm PRIVATE tsm_obj)
 apply_properties(tsm)
 # The production library additionally use version script
+if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
 set_property(TARGET tsm APPEND_STRING
     PROPERTY
         LINK_FLAGS " -Wl,--version-script=\"${CMAKE_CURRENT_SOURCE_DIR}/libtsm.sym\""
@@ -70,6 +71,7 @@
     PROPERTY
         LINK_DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/libtsm.sym"
 )
+endif()
 
 # Add an alias so that library can be used inside the build tree
 add_library(libtsm::tsm ALIAS tsm)

=== debian/changelog ===
libtsm (4.1.0-1) unstable; urgency=medium

  * New upstream release.
  * d/libtsm4.symbols: Update
  * d/control:
    - Update pkg-config to pkgconf in B-D.
    - Update Standards-Version: 4.7.2 (no changes required).
  * d/copyright: Update copyright year.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Sun, 28 Sep 2025 08:14:32 +0900

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
                cmake,
                debhelper-compat (= 13),
                libxkbcommon-dev,
-               pkg-config,
-Standards-Version: 4.6.0
+               pkgconf,
+Standards-Version: 4.7.2
 Homepage: https://github.com/Aetf/libtsm
 Rules-Requires-Root: no

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


include /usr/share/dpkg/default.mk


export DEB_BUILD_MAINT_OPTIONS := qa=+bug hardening=+all reproducible=+all
export DPKG_GENSYMBOLS_CHECK_LEVEL := 4


%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -B build-shared -- -DCMAKE_BUILD_TYPE=RelWithDebInfo \
	                                     -DBUILD_SHARED_LIBS=ON \
	                                     -DBUILD_TESTING=$(if $(filter nocheck,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)),OFF,ON) \
	                                     $(empty)
	DEB_BUILD_MAINT_OPTIONS="$(DEB_BUILD_MAINT_OPTIONS) optimize=-lto" \
		dh_auto_configure -B build-static --reload-all-buildenv-variables -- \
		                                 -DCMAKE_BUILD_TYPE=RelWithDebInfo \
	                                     -DBUILD_SHARED_LIBS=OFF \
	                                     -DBUILD_TESTING=$(if $(filter nocheck,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)),OFF,ON) \
	                                     $(empty)

override_dh_auto_build:
	dh_auto_build -B build-shared
	dh_auto_build -B build-static

override_dh_auto_test:
	dh_auto_test -B build-shared
	dh_auto_test -B build-static

override_dh_auto_install:
	dh_auto_install -B build-static
	# Delete static library's cmake files, so only the shared library versions
	# are installed
	rm -r debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/cmake
	dh_auto_install -B build-shared

override_dh_installdocs:
	dh_installdocs -plibtsm-dev --link-doc=libtsm4
	dh_installdocs --remaining-packages

override_dh_auto_clean:
	dh_auto_clean -B build-shared
	dh_auto_clean -B build-static

=== debian/watch ===
version=4

https://github.com/Aetf/libtsm/tags \
    .*/v@ANY_VERSION@\.tar\.(?:gz|bz2|xz) debian

## libtsm 4.3.0

=== debian/changelog ===
libtsm (4.3.0-2) unstable; urgency=medium

  * d/watch: Fix file format (Closes: #1124637)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Mon, 05 Jan 2026 14:51:23 +0900

libtsm (4.3.0-1) unstable; urgency=medium

  * New upstream release. (Closes: #1124469)
  * d/*: Update upstream url to https://github.com/kmscon/libtsm
  * d/*: Switch build system to meson
  * d/control: Add Vcs-Browser and Vcs-Git
  * d/control: Remove redundant Rules-Requires-Root field
  * d/copyright: Update copyright year
  * d/patches:
    - Add 0001-tsm-meson.build-Change-library-build-to-both_librari.patch
  * d/libtsm4.symbols: Update
  * d/watch: Update version to 5

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Sat, 03 Jan 2026 06:48:26 +0900

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS := qa=+bug hardening=+all reproducible=+all
export DPKG_GENSYMBOLS_CHECK_LEVEL := 4

%:
	dh $@ --builddirectory=build/ \
		--buildsystem=meson

## libtsm 4.4.2

=== debian/changelog ===
libtsm (4.4.2-0.1~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Boyuan Yang <byang@debian.org>  Tue, 10 Feb 2026 21:48:38 -0500

libtsm (4.4.2-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release. (Closes: #1126432, #1125286)
  * debian/rules: Explicitly define -Dtests=false configure flag when
    nocheck profile is detected. (Closes: #1126497)
  * debian/patches/:
    + 0001-tsm-meson.build-Change-library-build-to-both_librari.patch:
      Refresh the patch.
  * debian/libtsm4.symbols: Record new symbols.

 -- Boyuan Yang <byang@debian.org>  Sat, 31 Jan 2026 23:48:57 -0500

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,14 @@
 Section: libs
 Priority: optional
 Build-Depends: check <!nocheck>,
-               cmake,
+               meson,
                debhelper-compat (= 13),
                libxkbcommon-dev,
                pkgconf,
 Standards-Version: 4.7.2
-Homepage: https://github.com/Aetf/libtsm
-Rules-Requires-Root: no
+Homepage: https://github.com/kmscon/libtsm
+Vcs-Browser: https://salsa.debian.org/debian/libtsm
+Vcs-Git: https://salsa.debian.org/debian/libtsm.git
 
 Package: libtsm4
 Architecture: any

=== debian/watch ===
Version: 5

Template: Github
Owner: kmscon
Project: libtsm
